extern "C" {
    #include "nrf52.h"
}

#include "platform/cm4/SystemTick.h"
#include "platform/nrf52/InterruptGuardian.h"

using namespace pinetime::platform::cm4;
using namespace pinetime::platform::nrf52;

SystemTick::SystemTick()
    : InterruptHandler(InterruptGuardian::Nrf52IrqN::SYS_TICK_IRQ)
    , sys_tick(0)
{
}

void SystemTick::handle()
{
    this->sys_tick++;
}

void SystemTick::enable()
{
    SysTick_Config(SystemCoreClock / 1000);
}

void SystemTick::disable()
{
    SysTick->CTRL = 0;
}

uint32_t SystemTick::tick()
{
    return this->sys_tick;
}
